=== debian/changelog ===
freeorion (0.4.7-2) unstable; urgency=medium

  * Upload to unstable.
  * Declare compliance with Debian Policy 4.0.0.
  * Use https for Format field.

 -- Markus Koschany <apo@debian.org>  Fri, 23 Jun 2017 23:27:19 +0200

freeorion (0.4.7-1) experimental; urgency=medium

  * New upstream release.
  * Drop all patches. Fixed upstream.
  * Drop deprecated freeorion.menu file.
  * Don't convert and install the xpm icon any more.
  * Update get-orig-source target for new release.
  * Drop build-dependency on imagemagick.
  * Update debian/copyright for the latest release.

 -- Markus Koschany <apo@debian.org>  Sat, 06 May 2017 16:31:25 +0200
