=== AI/CMakeLists.txt ===
target_sources(freeorionca
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/AIInterface.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/AIInterface.cpp
)
