=== parse/CMakeLists.txt ===
target_sources(freeorionparseobj
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/Parse.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/CommonParams.h
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser.h
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParserImpl.h
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser.h
        ${CMAKE_CURRENT_LIST_DIR}/EffectParserImpl.h
        ${CMAKE_CURRENT_LIST_DIR}/EnumParser.h
        ${CMAKE_CURRENT_LIST_DIR}/Lexer.h
        ${CMAKE_CURRENT_LIST_DIR}/ParseImpl.h
        ${CMAKE_CURRENT_LIST_DIR}/ReportParseError.h
        ${CMAKE_CURRENT_LIST_DIR}/Tokens.h
        ${CMAKE_CURRENT_LIST_DIR}/ValueRefParser.h
        ${CMAKE_CURRENT_LIST_DIR}/ValueRefParserImpl.h
        ${CMAKE_CURRENT_LIST_DIR}/AlignmentsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/BuildingsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CommonParamsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser1.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser2.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser3.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser4.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser5.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser6.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser7.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/DoubleComplexValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/DoubleValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser1.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser2.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser3.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser4.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser5.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EmpireStatsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EncyclopediaParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EnumParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/FieldsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/FleetPlansParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/IntComplexValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/IntValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ItemsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/KeymapParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Lexer.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MonsterFleetPlansParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Parse.cpp
        ${CMAKE_CURRENT_LIST_DIR}/PlanetEnvironmentValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/PlanetSizeValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/PlanetTypeValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ReportParseError.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ShipDesignsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ShipHullsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ShipPartsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SpecialsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SpeciesParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/StarTypeValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/StringComplexValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/StringValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/TechsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Tokens.cpp
        ${CMAKE_CURRENT_LIST_DIR}/UniverseObjectTypeValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ValueRefParserImpl.cpp
)
