=== debian/changelog ===
freeorion (0.4.7.1-1) unstable; urgency=medium

  * New upstream release.
  * Declare compliance with Debian Policy 4.1.0.

 -- Markus Koschany <apo@debian.org>  Thu, 14 Sep 2017 08:29:04 +0200
