=== debian/control ===
--- 
+++ 
@@ -24,7 +24,7 @@
  libvorbis-dev,
  pkg-config,
  python
-Standards-Version: 4.0.0
+Standards-Version: 4.1.0
 Homepage: http://www.freeorion.org
 Vcs-Git: https://anonscm.debian.org/git/pkg-games/freeorion.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/freeorion.git
