=== debian/rules ===
--- 
+++ 
@@ -42,5 +42,5 @@
 	dh_python2 -pfreeorion-data /usr/share/games
 
 get-orig-source:
-	wget https://github.com/freeorion/freeorion/releases/download/v0.4.7/FreeOrion_v0.4.7_2017-04-24.60d06dc_Source.tar.gz
+	wget https://github.com/freeorion/freeorion/releases/download/v0.4.7.1/FreeOrion_v0.4.7.1_2017-09-03.139ffd9_Source.tar.gz
